--[[

̃t@CRampageAÏꕔłB

RampageAI̓t[\tgł; Free Software FoundationzGNUʌOp_񏑂̏̂ƂōĔzzщς邱Ƃł܂;
GNUCZXo[W2A܂(Ȃ̑I)2ȑÕo[WɂāB

RampageAÍALpłƂ]Ĕzz܂B
*ۏ؂Ȃ*; s̐A̖ړÎ߂̓K̈ÖٓIȕۏ؂ȂĂB 
̑̏ڍׂɊւẮAGNUʌOp_񏑂ĂB

RampageAIƋGNUʌOp_񏑂̃Rs[𓯎Ɏ󂯎ׂł;
łȂȂAȉ̏֏ȂB
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

--------------------
-- Timeout Object --
--------------------

Timeout = { }
Timeout.timeouts = { n=0 }

-- Add a new timeout
function Timeout.add(tEnd,func,repeatable)
	-- Get the current time
	local start = GetTick()

	-- Check our repeat value
	if repeatable == nil then
		repeatable = false
	end

	-- Setup a new item in our list
	Timeout.timeouts.n = Timeout.timeouts.n + 1
	Timeout.timeouts[Timeout.timeouts.n] =
		{ start, tEnd, func, repeatable }

	-- Return the place of it
	return Timeout.timeouts.n
end

-- Check all the timeouts
function Timeout.iterate()
	-- Get our current ticks
	local ticks = GetTick()

	-- Loop through all of our timeouts
	local i,timeout
	for i=1,Timeout.timeouts.n do
		-- Grab the timeout
		timeout = Timeout.timeouts[i]

		-- Make sure its not a nil timeout
		if timeout ~= nil then
			-- Check if its time to call the function
			if (timeout[1]+timeout[2]) <= ticks then
				-- Call the function, and pass it the amount of time
				-- that has passed
				local func = timeout[3]
				func(ticks - timeout[1])

				-- Check if we should repeat
				if timeout[4] then
					timeout[1] = ticks
				else
					-- Remove the timeout
					Timeout.timeouts[i] = nil
				end
			end
		end
	end
end