--[[

̃t@CRampageAÏꕔłB

RampageAI̓t[\tgł; Free Software FoundationzGNUʌOp_񏑂̏̂ƂōĔzzщς邱Ƃł܂;
GNUCZXo[W2A܂(Ȃ̑I)2ȑÕo[WɂāB

RampageAÍALpłƂ]Ĕzz܂B
*ۏ؂Ȃ*; s̐A̖ړÎ߂̓K̈ÖٓIȕۏ؂ȂĂB 
̑̏ڍׂɊւẮAGNUʌOp_񏑂ĂB

RampageAIƋGNUʌOp_񏑂̃Rs[𓯎Ɏ󂯎ׂł;
łȂȂAȉ̏֏ȂB
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

------------------
-- Table Object --
------------------

Table = { }

-- Create a new table
function Table.new()
	return { n=0 }
end

-- Get table size
function Table.getn(t)
	-- See if the table has an "n" element
	if t.n == nil then
		-- Otherwise count until we find nil
		local i = 0
		while t[i+1] ~= nil do i=i+1 end
		t.n = i
	end

	return t.n
end

-- Set the table size
function Table.setn(t,size)
	-- Get the table size
	local len = Table.getn(t)
	
	-- Check if we're reducing the size
	if size < len then
		-- Remove all elements after size
		local i
		for i=len,size+1,-1 do
			t[i]=nil
		end
	end

	-- Set n
	t.n=size
end

-- Add an element to a table
function Table.insert(t,pos,item)
	-- Increase number of items
	t.n = Table.getn(t) + 1

	-- Check if we were given 3 arguments
	if item == nil then
		-- Nope, only 2, 2nd one is the item
		item = pos
		pos = t.n
	end

	-- Shift everything backwards
	local i
	for i=t.n,pos+1,-1 do
		t[i]=t[i-1]
	end

	-- Insert the item
	t[pos]=item
end

-- Remove an element from a table
function Table.remove(t,pos)
	-- Check if the item exists
	if Table.getn(t) < pos then
		return
	end

	-- Shift everythign forward
	local i
	for i=pos,t.n-1 do
		t[i]=t[i+1]
	end

	-- Set the last element to nil
	t[t.n]=nil
	t.n=t.n-1
end